#include <Bounce2.h>                                            // Bibliothek für Taste

#define Taster_PIN 2                                            // Pin für Taste
const int Kontroll_LED_PIN = 7;                                // PIN für Buttonzusatndsanzeige    

byte LED_Licht[] = {9,11,8,12};                                 // LED Pins für normale Lichter (gemeinsam erweiterbar)
unsigned long LED_Tackt[] = {22000, 30000, 50000, 90000};       // LED Blinktakt für LED-Lichter (gemeinsam erweiterbar)

byte LED_TV_flimmern_pwm = 10;                                  // PWM Pin für das TV-Flimmern
unsigned long FlimmernBeginn,Flimmer_Ende;                      // Start- und Endzeiten für TV-Flimmern
unsigned long LED_Zeit[sizeof(LED_Licht)];                      // Zeit merken (millis)
int Flimmern_Start = 2000;                                      // Anfangszeit für das TV-Flimmern nach Einschalten von Pin 8
int Flimmern_Ende = 25000;                                      // Leuchtdauer für das TV-Flimmern (max 32000 - int)

const int Sensor = A2;

bool Nachtmodus_aktiv = false;
bool An_Aus_Status = false;

Bounce2::Button ON_OFF = Bounce2::Button();

void setup() {
  Serial.begin(9600);
  pinMode(LED_TV_flimmern_pwm, OUTPUT);                         // Alle verwendeten Pins auf OUTPUT setzen
  for (int i=0;i<sizeof(LED_Licht);i++) pinMode(LED_Licht[i], OUTPUT);
  pinMode(Sensor,INPUT);                                        //Sensor
  ON_OFF.attach(Taster_PIN,INPUT_PULLUP);
  }

  boolean milliSekundenTakt(unsigned long Dauer, unsigned long & alterWert) {
    // Dauer:  Zeitraum einer Blinkphase
    // alterWert: Speichert Timers-millis
    // Rückgabe: true wenn die Zeit abgelaufen ist, sonst false
    if (millis() - alterWert < Dauer) return false;
    while (millis() - alterWert >= Dauer) alterWert += Dauer;
    return true;  
  }

void Nachtprogramm() {
  // Alle gleichmäßig blinkenden LED_Licht in ihrem eigenen Takt blinken lassen  
  for (int i=0;i<sizeof(LED_Licht);i++) {                       // alle LED_Licht in einer Schleife durchgehen 
    if (milliSekundenTakt(LED_Tackt[i],LED_Zeit[i])) {          // Takt für diese LED abgelaufen?
      digitalWrite(LED_Licht[i],!digitalRead(LED_Licht[i]));    // wenn ja ==> Umschalten
      if (LED_Licht[i]==8 && digitalRead(LED_Licht[i])) {       // Pin-8 LED wurde gerade eingeschaltet
        FlimmernBeginn=millis()+2000;                           // Anfangszeit für das Flimmern setzen
        Flimmer_Ende =millis()+25000;                           // Endzeit für das Flimmern setzen
        }  
      Serial.print("Pin ");Serial.print(LED_Licht[i]);Serial.print(" = ");Serial.println(digitalRead(LED_Licht[i]));
      Serial.println(analogRead(Sensor));
      }
    }
  }

void Tagprogramm(){
  for (int i=0;i<sizeof(LED_Licht);i++) {                       // alle LED_Licht in einer Schleife durchgehen
    digitalWrite(LED_Licht[i], LOW);
    }
  digitalWrite(LED_TV_flimmern_pwm, LOW);
 // Serial.println("aus");
}

void flimmernPwmPin() {
  // Die flimmernde LED im Zufallsmodus flimmern lassen
  static unsigned long alterWert;
  static int Flimmern_Dauer=200;
  static byte Flimmern_Helligkeit;
  if (milliSekundenTakt(Flimmern_Dauer, alterWert)) {           // Takt abgelaufen?
    Flimmern_Dauer=1 + random(200);                             // neue Flimmerdauer als Zufallswert
    if (millis() > FlimmernBeginn && millis() < Flimmer_Ende)
      Flimmern_Helligkeit = random(256);                        // neue Flimmerhelligkeit als Zufallswert
    else  
      Flimmern_Helligkeit = 0;                                  // Flimmern aus wenn falsche Zeit zum Flimmern
      analogWrite(LED_TV_flimmern_pwm, Flimmern_Helligkeit); 
    }  
  }

void loop() {
  ON_OFF.update();

  if(ON_OFF.pressed()) {
    An_Aus_Status = !An_Aus_Status;
    digitalWrite(Kontroll_LED_PIN, An_Aus_Status);  
    Serial.println(An_Aus_Status);       
    }

  if(analogRead(Sensor) > 600) {
    Nachtmodus_aktiv = true;
    }
  else {
    Nachtmodus_aktiv = false;
    }

  if ((Nachtmodus_aktiv)||(An_Aus_Status)){
    Nachtprogramm();
    flimmernPwmPin();
    }
  else {
    Tagprogramm(); 
    }
  }
